package xyz.twokilohertz.mixin;

import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1838;
import net.minecraft.class_1937;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import xyz.twokilohertz.HotbarReplace;

@Mixin(class_1799.class)
public class ItemStackMixin {
    class_1792 lastUsedItem = null;

    @Inject(at = @At("HEAD"), method = "use")
    private void ItemStack_use_HEAD(class_1937 world, class_1657 player, class_1268 hand,
            CallbackInfoReturnable<class_1269> info) {
        if (!world.method_8608())
            return;

        class_1792 item = player.method_5998(hand).method_7909();
        if (item == null)
            return;

        lastUsedItem = item;
    }

    @Inject(at = @At("HEAD"), method = "useOnBlock")
    private void ItemStack_useOnBlock_HEAD(class_1838 context,
            CallbackInfoReturnable<class_1269> info) {
        if (!context.method_8045().method_8608())
            return;

        class_1792 item = context.method_8036().method_5998(context.method_20287()).method_7909();
        if (item == null)
            return;

        lastUsedItem = item;
    }

    @Inject(at = @At("HEAD"), method = "useOnEntity")
    private void ItemStack_useOnEntity_HEAD(class_1657 player, class_1309 entity, class_1268 hand,
            CallbackInfoReturnable<class_1269> info) {
        if (!player.method_37908().method_8608())
            return;

        class_1792 item = player.method_5998(hand).method_7909();
        if (item == null)
            return;

        lastUsedItem = item;
    }

    @Inject(at = @At("TAIL"), method = "use")
    private void ItemStack_use_TAIL(class_1937 world, class_1657 player, class_1268 hand,
            CallbackInfoReturnable<class_1269> info) {
        if (!world.method_8608())
            return;

        if (info.getReturnValue() != class_1269.field_5812)
            return;

        class_1799 stack = player.method_5998(hand);

        if (stack.method_7947() > 1)
            return;

        HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
    }

    @Inject(at = @At("TAIL"), method = "useOnBlock")
    private void ItemStack_useOnBlock_TAIL(class_1838 context, CallbackInfoReturnable<class_1269> info) {
        if (!context.method_8045().method_8608())
            return;

        if (info.getReturnValue() != class_1269.field_5812)
            return;

        class_1657 player = context.method_8036();
        class_1268 hand = context.method_20287();
        class_1799 stack = player.method_5998(hand);

        if (stack.method_7947() != 0)
            return;

        HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
    }

    @Inject(at = @At("TAIL"), method = "useOnEntity")
    private void ItemStack_useOnEntity_TAIL(class_1657 player, class_1309 entity, class_1268 hand,
            CallbackInfoReturnable<class_1269> info) {
        if (info.getReturnValue() != class_1269.field_5812)
            return;

        class_1799 stack = player.method_5998(hand);

        if (stack.method_7947() > 1)
            return;

        HotbarReplace.tryReplaceSlot(player, hand, lastUsedItem);
    }

    @Inject(at = @At("HEAD"), method = "Lnet/minecraft/item/ItemStack;finishUsing(Lnet/minecraft/world/World;Lnet/minecraft/entity/LivingEntity;)Lnet/minecraft/item/ItemStack;")
    private void ItemStack_finishUsing_HEAD(class_1937 world, class_1309 user,
            CallbackInfoReturnable<class_1799> info) {
        if (!world.method_8608())
            return;

        class_1799 stack = (class_1799) (Object) this;
        // ItemStack stack = info.getReturnValue(); -- only applicable when injecting at TAIL

        if (lastUsedItem != stack.method_7909())
            return;

        // Food items disappear into thin (minecraft:)air before their stack size reaches 0
        if (stack.method_7947() > 1)
            return;

        if (!user.method_31747())
            return;

        class_1657 player = (class_1657) user;

        if (!player.method_7340())
            return;

        HotbarReplace.tryReplaceSlot(player, player.method_6058(), lastUsedItem);
    }
}
